import os,sys
from xml.dom.minidom import parse, parseString
import matplotlib.pyplot as plt
from SensorGPS import sensor
from SensordataGPS import sensordata
import matplotlib.dates as mdates
from datetime import datetime
import time

# Hacemos la lista de objetos sensores
def DoListSensor(NumberSensor):
	for i in NumberSensor:
		ListSensor.add(sensor(i))
		
# Obtenemos el numero de sensores de los que recogemos datos
def ListNumberSensor(arg):	
	EntryTree = parse(arg)
	listEntry = EntryTree.getElementsByTagName('entry')
	# Obtenemos el arbol Dom y  comprobamos que tengamos todos los nodos hijos que tiene que aparecer, si no se da por mala la informacion obtenida en este envio y se obvia.
	for i in listEntry:
		b = False
		try:
			Nodesensor = i.getElementsByTagName('sensor')[0] 
			Nodelat = i.getElementsByTagName('lat')[0]
			Nodelong = i.getElementsByTagName('long')[0]
			Nodedate = i.getElementsByTagName('date')[0]
			Nodeclock = i.getElementsByTagName('clock')[0]

		except IndexError:
			b=True
		if(b == True):
			continue
		#Si no da error, introducimos los numeros de los sensores, para crear una lista	
		Sensor = Nodesensor.childNodes[0].nodeValue
		NumberSensor.add(int(Sensor))
		
def parser(arg):	
	EntryTree = parse(arg)
	listEntry = EntryTree.getElementsByTagName('entry')
	# Obtenemos el arbol Dom
	if(len(listEntry)!=0):
		for i in listEntry:
			b = False
			try:
				# Comprobamos que los datos obtenidos, estan completos
				Nodesensor = i.getElementsByTagName('sensor')[0] 
				Nodelat = i.getElementsByTagName('lat')[0]
				Nodelong = i.getElementsByTagName('long')[0]
				Nodedate = i.getElementsByTagName('date')[0]
				Nodeclock = i.getElementsByTagName('clock')[0]
			except IndexError:
				b = True
				# Si no pues volvemos ha iterar al siguiente nodo
			if(b == True):
				continue 
			Sensor = Nodesensor.childNodes[0].nodeValue
			Lat = Nodelat.childNodes[0].nodeValue
			Long = Nodelong.childNodes[0].nodeValue
			Clock = Nodeclock.childNodes[0].nodeValue
			Date = Nodedate.childNodes[0].nodeValue
			# Obtenemos los valores de los nodos, y los guardamos en la lista de datos del objeto sensor correspondiente
			for i in ListSensor:
			# Iteramos en la lista de sensores, comprobamos que sea igual y si es el objeto sensor que queremos, creamos el objeto sensordata y lo introducimos en la lista de datos que tiene el objeto sensor 
				if(i.getNumberSensor()==int(Sensor)):
					mediolat = Lat.partition(" ");
					mediolon = Long.partition(" ");
					if(not mediolat[0] == '99999.999' and not mediolon[0] == '99999.999'): 
						SensorData = sensordata(Clock+' '+Date, str(float(mediolat[0])/100)+' '+mediolat[2], str(float(mediolon[0])/100)+' '+mediolon[2]) 
						i.inputData(SensorData)
	else:
		print 'No hay datos para parsear'
def DoText(filename, Sensor):
	ListData = Sensor.getListData()
	f = open (filename, 'a')
	if(len(ListData) == 1):
		valor = ListData[0]
		f.write(str(valor.getLat())+','+str(valor.getLong())+'	 Nodo Sensor '+ str(Sensor.getNumberSensor())+'	 Esta son las coordenadas desde las ' +str(valor.getDate())+'\n')
	else:
		for i in ListData:
			f.write(str(i.getLat())+','+str(i.getLong())+'	 Nodo Sensor '+ str(Sensor.getNumberSensor())+'	 Esta son las coordenadas a las ' +str(i.getDate())+'\n')
	f.close()
	# Iteramos en la lista de sensores, comprobamos que sea igual y si es el objeto sensor que queremos, creamos el objeto sensordata y lo introducimos en la lista de datos que tiene el objeto sensor 

				
# Iteramos en los argumentos de entrada
if (len(sys.argv) == 1):
	print "Usage: " + sys.argv[0] + " fichero1.xml ... fichero2.xml"
	sys.exit
else:
	filename = "txtcoordenadas.txt"
	NumberSensor = set()
	ListSensor = set()
	for arg in range(1,len(sys.argv)):
		ListNumberSensor(sys.argv[arg])
	DoListSensor(NumberSensor)
	# Inicializamos las estructuras almacenamiento de datos que tenemos que usar para el parser
	for arg in range(1,len(sys.argv)):
		parser(sys.argv[arg])
	if(len(ListSensor)==0):
		sys.exit
	else:
		f = open(filename, 'a')
		f.write('point	title	description	icon\n')
		f.close()
		for i in ListSensor:
			DoText(filename, i)

