#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include <stdio.h>
#include <arpa/inet.h>
#include <errno.h>
#include <sys/wait.h>
#include <signal.h>

#define TAM_MENSAJE 174

int crear_conexion();
void procesar_conexion(int socket_conexion);

int main(int argc, char * argv[])
{
	int  socket_conexion, puerto;
	
	/* Almacenamos el puerto en una variable de tipo entero */

	/* Creamos un socket de conexion */
	socket_conexion = crear_conexion();
	
	/* Comunicacion */
	procesar_conexion(socket_conexion);

	
	/* Cerramos el socket */
	close(socket_conexion);

}

/* Crea un socket de escucha en modo stream en el dominio de Internet */
int crear_conexion()
{
	int s;
	struct sockaddr_in sin;
	struct hostent *hp;
	char hostname[250];
	
	/* Obtenemos la direccin IP a partir del nombre */
	gethostname(hostname, sizeof(hostname));
	hp = gethostbyname (hostname);
	s = socket(AF_INET, SOCK_STREAM,0);
	sin.sin_family = AF_INET;
	sin.sin_port = htons(9999);
	memmove (&sin.sin_addr, hp->h_addr, hp->h_length);
	/* Nos conectamos al servidor */
	int valor = connect(s,(struct sockaddr *) &sin, sizeof(sin));
	fprintf(stdout,"%d \n",s);
	return s;
}




/* Comunicacin con el servidor */
void procesar_conexion(int socket_conexion)
{
	char mensaje[TAM_MENSAJE];
  	int n_bytes=0;
  	int fin=0;
  	while(1)
    	{	
			n_bytes=send(socket_conexion,"GET /xml-arduino/protocol HTTP/1.1\n",strlen("GET /xml-arduino/protocol HTTP/1.1\n"),0);
			if (n_bytes < 0)
        	{          		
          		fprintf(stderr,"Error en send\n");
      			exit(EXIT_FAILURE);
			}
			recv(socket_conexion,mensaje,sizeof(mensaje),0);
			sprintf(mensaje,"%s","HTTP/1.1 200 OK\n Content-Type: text/plain;charset=UTF-8\n Content-Length: 49\n\n <xml><entry><sensor>1</sensor><humedity>54</humedity><temperature>24</temperature></entry></xml>");
      		n_bytes=send(socket_conexion,mensaje,strlen(mensaje),0);
			if (n_bytes < 0)
        	{          		
          		fprintf(stderr,"Error en send\n");
      			exit(EXIT_FAILURE);
			}
    	}
}
